/****************************************/
/*					*/
/*	Auto Demo Recorder		*/
/*	by IzI				*/
/*					*/
/****************************************/

#include <amxmodx>

new g_Toggle, g_DMod, g_UseNI, g_RStartAfter, g_DemoName;

public plugin_init()
{ 
	register_plugin("Auto Demo Recorder", "1.3", "IzI")
	g_Toggle 		= register_cvar("amx_demo",		"1");
	g_DMod			= register_cvar("amx_demo_mode",	"0");
	g_UseNI 		= register_cvar("amx_demo_steamid",	"0");
	g_RStartAfter 		= register_cvar("amx_demo_rectime",	"15");	// If it is less than 5, it will automatically set to 5, but willn't apply the changes to the console. I recoment to use default settings.
	g_DemoName 		= register_cvar("amx_demo_name",	"Autorecorded demo");
	register_dictionary("demorecorder.txt");
}

public client_putinserver(id)
{
	if(get_pcvar_num(g_Toggle))
	{
		if(get_pcvar_float(g_RStartAfter) < 5)
			set_pcvar_num(g_RStartAfter, 5);
		set_task(get_pcvar_float(g_RStartAfter), "Record", id);
	}
}

public Record(id)
{
	if(!is_user_connected(id) || get_pcvar_num(g_Toggle) != 1)
		return;

	// Getting time, client SteamID, server's name, server's ip with port.
	new iDName[64], iSName[32], iCID[32], iSIP[22], iTimedata[9];
	new iUseIN = get_pcvar_num(g_UseNI);
	new iDMod = get_pcvar_num(g_DMod);
	get_pcvar_string(g_DemoName, iDName, 63);
	get_time("%H:%M:%S", iTimedata, 8);
	get_user_name(0, iSName, 31);
	get_user_ip(0, iSIP, 21, 0);
	get_user_authid(id, iCID, 31);

	// Replacing signs.
	replace_all(iSName, 31, ":", "_");
	replace_all(iSName, 31, ".", "_");
	replace_all(iSName, 31, "*", "_");
	replace_all(iSName, 31, "/", "_");
	replace_all(iSName, 31, "|", "_");
	replace_all(iSName, 31, "\", "_");
	replace_all(iSName, 31, "?", "_");
	replace_all(iCID, 31, ":", "_");
	replace_all(iCID, 31, ".", "_");
	replace_all(iSIP, 21, ":", "_");
	replace_all(iSIP, 21, ".", "'");
	replace_all(iSIP, 21, "*", "_");
	replace_all(iSIP, 21, "/", "_");
	replace_all(iSIP, 21, "|", "_");
	replace_all(iSIP, 21, "\", "_");
	replace_all(iSIP, 21, "?", "_");

	// Displaying messages.
	switch(iUseIN)
	{
		case 0:
		{
			switch(iDMod)
			{
				case 0:
				{
					client_cmd(id, "stop; record ^"%s^"", iDName);
					client_print(id, print_chat, "[AMXX] %L ^"%s.dem^"", LANG_PLAYER, "RECORDINGIN", iDName);
					client_print(id, print_chat, "[AMXX] %L", LANG_PLAYER, "RECORDINGAT", iTimedata);
				}
				case 1:
				{
					client_cmd(id, "stop; record ^"%s^"", iSIP);
					client_print(id, print_chat, "[AMXX] %L ^"%s.dem^"", LANG_PLAYER, "RECORDINGIN", iSIP);
					client_print(id, print_chat, "[AMXX] %L", LANG_PLAYER, "RECORDINGAT", iTimedata);
				}
				case 2:
				{
					client_cmd(id, "stop; record ^"%s^"", iSName);
					client_print(id, print_chat, "[AMXX] %L ^"%s.dem^"", LANG_PLAYER, "RECORDINGIN", iSName);
					client_print(id, print_chat, "[AMXX] %L", LANG_PLAYER, "RECORDINGAT", iTimedata);
				}
			}
		}
		case 1:
		{
			switch(iDMod)
			{
				case 0:
				{
					client_cmd(id, "stop; record ^"[%s]%s^"", iCID, iDName);
					client_print(id, print_chat, "[AMXX] %L ^"[%s]%s.dem^"", LANG_PLAYER, "RECORDINGIN", iCID, iDName);
					client_print(id, print_chat, "[AMXX] %L", LANG_PLAYER, "RECORDINGAT", iTimedata);
				}
				case 1:
				{
					client_cmd(id, "stop; record ^"[%s]%s^"", iCID, iSIP);
					client_print(id, print_chat, "[AMXX] %L ^"[%s]%s.dem^"", LANG_PLAYER, "RECORDINGIN", iCID, iSIP);
					client_print(id, print_chat, "[AMXX] %L", LANG_PLAYER, "RECORDINGAT", iTimedata);
				}
				case 2:
				{
					client_cmd(id, "stop; record ^"[%s]%s^"", iCID, iSName);
					client_print(id, print_chat, "[AMXX] %L ^"[%s]%s.dem^"", LANG_PLAYER, "RECORDINGIN", iCID, iSName);
					client_print(id, print_chat, "[AMXX] %L", LANG_PLAYER, "RECORDINGAT", iTimedata);
				}
			}
		}
	}
}
